Ruby - Bug #14358

URl.encode_www_form_component doesn't encode bad chars properly
01/15/2018 11:53 AM - phluid61 (Matthew Kerwin)

Status: Closed
Priority: Normal
Assignee: akira (akira yamada)

Target version:

ruby -v: ruby 2.5.0p0 (2017-12-25 revision Backport: 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:
61468) [x86_64-linux] UNKNOWN

Description

URI.encode_www_form_component "\uO2DA", Encoding::WINDOWS_1252
#=> "%26730%3B"

# Expected:
#=> "%26%23730%3B"

As per http://www.w3.0rg/TR/2013/CR-htmI5-20130806/forms.html#url-encoded-form-data :

"For each character in the entry's name and value that cannot be expressed using the selected character encoding, replace the
character by a string consisting of a U+0026 AMPERSAND character (&), a "#" (U+0023) character, one or more ASCI!I digits
representing the Unicode code point of the character in base ten, and finally a ";" (U+003B) character.”

Associated revisions

Revision a2c26fe1c6d49b54494b7c6301cc4c77596eecOc - 09/27/2019 02:43 PM - jeremyevans (Jeremy Evans)

Fix fallback in URl.encode_www_form_component to include #

Patch from Matthew Kerwin.

Fixes [Bug #14358]

Revision a2c26fe1c6d49b54494b7c¢6301cc4c77596eecOc - 09/27/2019 02:43 PM - jeremyevans (Jeremy Evans)
Fix fallback in URI.encode_www_form_component to include #

Patch from Matthew Kerwin.

Fixes [Bug #14358]

Revision a2c26fe1 - 09/27/2019 02:43 PM - jeremyevans (Jeremy Evans)

Fix fallback in URI.encode_www_form_component to include #

Patch from Matthew Kerwin.

Fixes [Bug #14358]

History

#1 - 01/19/2018 12:20 AM - phluid61 (Matthew Kerwin)
- ruby -v set to ruby 2.5.0p0 (2017-12-25 revision 61468) [x86_64-linux]

#2 - 06/20/2019 09:50 PM - jeremyevans0 (Jeremy Evans)
- File uri-encode-form-compontent.patch added
- Status changed from Open to Assigned

- Assignee set to akira (akira yamada)

| agree this is a bug that should be fixed, and the patch is a proper way to fix it. Attached is an updated patch that applies against the master branch,
along with a test.

#3 - 09/27/2019 02:44 PM - jeremyevans (Jeremy Evans)
http://www.w3.org/TR/2013/CR-html5-20130806/forms.html#url-encoded-form-data

- Status changed from Assigned to Closed

Applied in changeset git|a2c26fe1c6d49b54494b7c6301cc4c77596eecOc.

Fix fallback in URI.encode_www_form_component to include #
Patch from Matthew Kerwin.

Fixes [Bug #14358]

Files
uri_encoding.patch 556 Bytes 01/15/2018 phluidé1 (Matthew Kerwin)
uri-encode-form-compontent.patch 1.52 KB 06/20/2019 jeremyevans0 (Jeremy Evans)
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/a2c26fe1c6d49b54494b7c6301cc4c77596eec0c
https://bugs.ruby-lang.org/issues/14358
